//a big thanks to neil hickey for helping us develop this code and we couldn't have done it without him

//includes
#include <EEPROM.h>
#include <SoftwareSerial.h>

//defines

//BUTTONS
#define BTN 12
#define mBTN 13

//QIK INTERFACE

//QIK INTERFACE
#define error 4
#define RST 5
#define RX 6
#define TX 7
//globals (yikes)
//for tracking motion state, serial vs eeprom instructions, and/or demo mode
//state can be either 0=forward,1=backward,2=spinright,3=spinleft,4=stop/brake,5=idle/freewheel
boolean serial= true; 
boolean first = true;
boolean demo = false;
boolean btn = true;

int state = 0;

int mode = 0;

//set timeout in milliseconds
long timeout = 10000;

//implement serial connection on designated RX/TX I/O-pins
SoftwareSerial cntrl(RX, TX);





void setup(){
  if(serial)
    Serial.begin(38400);

  pinMode(BTN,OUTPUT);
  pinMode(mBTN,OUTPUT);

  cntrl.begin(38400);
  mode =  writeEE(mode);

  delay(100);
  reset();

  cntrl.write((byte)0xAA);

  checkErr();

  delay(100);
  if(serial)
    Serial.println("SERIAL MODE");
  else
    Serial.println("EEPROM MODE");
  delay(10);
  Serial.println("DBG: test forward");
  forward();
}





//main
void loop(){

  if(demo)
  {
    Serial.println("DEMOOOO MODE");
    runDemo();
  }
  else{

    if(cntrl.available() >0){
      Serial.println("DBG: INCOMING");
      Serial.print(cntrl.read());
    }

    if(serial)
      //      serialCheck();
      //    else if(btn)
      btnCheck();
    else
      eeCheck();
  }
}



//-----------------------------------------------------------------
//flow control
//everything relating to the system flow

char runnin; //another ugly global


//demo mode
void runDemo(){
  runnin = 0;
  while(true){
    forward();
    delay(2000);
    idle();
    delay(2000);
    backward();
    delay(2000);
    idle();
    delay(2000);
    spinl();
    delay(5000);
    idle();
    delay(2000);
    spinr();
    delay(5000);
    idle();
    delay(2000);
    brake();
    delay(100);
    runnin ++;
    if(runnin == 10){
      while(true){
      }
    }
  }
}

//serial mode
void serialCheck()
{

  if(Serial.available() >0){

    char in=Serial.read();
    if(in != runnin)
    {
      switch(in){
      case 'f':
        Serial.println("DBG: FORWARD");
        forward();
        break;

      case 'b':
        Serial.println("DBG: BACK UP");
        backward();
        break;

      case 'l':
        Serial.println("DBG: spin one way");
        spinl();
        break;

      case 'r':
        Serial.println("DBG: spin the other way");
        spinr();
        break;


      case 's':
        Serial.println("DBG: BRAKE");
        brake();
        break;

      case 'i':
        Serial.println("DBG: IDLE");
        idle();
        break;

      default:
        break;

      }
      runnin = in;

    }
  }
}

//eeprom mode
void eeCheck(){

  if(first){
    switch(mode)
    {

    case 0:
      Serial.println("DBG-EE: ATTEMPTING FORWARD");
      forward();
      break;
    case 1:
      Serial.println("DBG-EE: ATTEMPTING SPINL");
      spinl();
      break;
    case 2:
      Serial.println("DBG-EE: ATTEMPTING SPINR");
      spinr();
      break;
    case 3:
      Serial.println("DBG-EE: ATTEMPTING BACK");
      backward();
      break;
    case 4:
      Serial.println("DBG-EE: ATTEMPTING IDLE");
      idle();
      break;
    default:
      break;
    }

    first =false;
  }

}


long refm = 0;
long diff = 100;

void btnCheck(){
  while (true){

    if(millis()-refm > timeout)brake();

    if(digitalRead(BTN) == HIGH){
      if((millis() - refm) > diff){
        refm=millis();
        buttonBot();
      }
    }
    else  if(digitalRead(mBTN) == HIGH){

      if(serial)Serial.println("DBG-IO: GOT MIDDLE BTN");

      if((millis() - refm) > diff){
        switch (state){
        case 2:
          spinl();
          break;
        case 3:
          spinr();
          break;
        default:
          spinl();
          break;

        }
        refm=millis();
      }
    }
  }

}



//button bot mode
int c=0;

void buttonBot(){

  switch(c){
  case 0:
    if(serial)Serial.println("DBG-LOGIC: mode 0");
    forward();
    delay(100);
    break;
  case 1:
    if(serial)Serial.println("DBG-LOGIC: mode 1");
    backward();
    delay(100);
    break;
  case 2:
    if(serial)Serial.println("DBG-LOGIC: mode 2");
    idle();
    delay(100);
    break;

  case 3:
    fancy_m();
    delay(100);
    break;


  case 4:
    if(serial)Serial.println("DBG-LOGIC: mode 4");

    fancy_s();
    delay(100);
    break;

  case 5:
    if(serial)Serial.println("DBG-LOGIC: mode 5");
    freesixty();

    forward();
    delay(100);
    break;

  case 6:
    if(serial)Serial.println("DBG-LOGIC: mode 6");
    freesixty(800);
    backward();
    delay(100);
    break;

  default:
    delay(100);
    break;

  }
  c++;
  c=c%7;
  c=(c>25)?0:c;
  if(serial){
    Serial.print("DBG-logic: counter = ");
    Serial.println(c);
  }
  //c+=(int)random(2,8);

}

void freesixty(){
  spinr();
  delay(800);
  idle();
}

void freesixty(int d){
  spinl();
  delay(d);
  idle();
}



//-----------------------------------------------------------------
//logic helpers
//everything relating to interfacing the arduino w qik cntrl

void reset(){
  digitalWrite(RST, LOW);
  delay(100);
  digitalWrite(RST,HIGH);
  delay(20);
}
void checkErr(){

  if(digitalRead(error) == HIGH){

    cntrl.write((byte)0x82);

    Serial.println("DBG: cleared error byte");
  }
}


//returns the current mode
int writeEE(int m){
  m = EEPROM.read(0);
  m ++;
  m = m%5;

  EEPROM.write(0, m);
  Serial.print("DBG:mode");
  Serial.println(mode);

  return m;
}



//-----------------------------------------------------------------
//motion helpers 
//all the functions that make our baby move

void forward(){
  //forward motion
  cntrl.write(137);
  cntrl.write(40);
  cntrl.write((byte)(0x8F));
  cntrl.write(40);
  state = 0;
}

void backward(){
  //reverse motors
  cntrl.write((byte)(0x8B));
  cntrl.write((byte)(40));
  cntrl.write((byte)(0x8D));
  cntrl.write((byte)(40));
  state = 1;
}

void spinr(){
  //set motorB forward && motorA backward
  cntrl.write((byte)(0x89));
  cntrl.write((byte)(40));
  cntrl.write((byte)(0x8D));
  cntrl.write((byte)(40));
  state = 2;
}

void spinl(){
  //set motorA forward && motorB backward
  cntrl.write((byte)(0x8B));
  cntrl.write((byte)(40));
  cntrl.write((byte)(0x8F));
  cntrl.write((byte)(40));
  state = 3;
}

void brake(){
  //set boath motors to break
  cntrl.write((byte)(0x88));
  cntrl.write((byte)0x0);
  cntrl.write((byte)(0x8E));
  cntrl.write((byte)(0x0));
  state = 4;
}

void idle(){
  //set boath motors to coast
  cntrl.write((byte)(0x86));
  cntrl.write((byte)(0x87));
  state = 5;
}





void fancy_s(){
  while (true){
    if(digitalRead(BTN == HIGH)){
      //    buttonBot();
      return;
    }
    spinl();
    delay(2000);
    spinr();
    delay(2000);
    if(digitalRead(BTN == HIGH)){
      //    buttonBot();
      return;
    }
  }
}
void fancy_m(){
  while (true){
    if(digitalRead(BTN == HIGH)){
      //    buttonBot();
      return;
    }
    backward();
    delay(2000);
    forward();
    delay(2000);
    if(digitalRead(BTN == HIGH)){
      //    buttonBot();
      return;
    }
  }
}















